Attribute VB_Name = "Module1"
Option Explicit ' Requires programmer to declare all variables
Sub ChkSta(strStaNum As String, iEc As Integer, imode As Integer)
'
' Purpose:
' To read and check station number from text1.txt
' History:
' Version 1.0 May 2004 by G.E. Granato
' strStaNum           'input NWIS station number as string
' iec                 'output error code 0 = everything ok
' imode               ' mode 1= interactive 2= batch
' Arguments
Dim ci As Integer                 ' check loop integer 1
Dim cj As Integer                 ' check loop Integer
Dim cnum As Integer               ' check number sum
Dim n1 As Integer                 ' Integer test variable
Dim n2 As Integer                 ' Integer count variable
Dim ck2 As Variant                ' variant
Dim strErrMsg As String           ' Error string
On Error GoTo Err_ChkSta:
iEc = 0
' trim leading or trailing spaces
   strStaNum = Trim(strStaNum)
'  trim leading or trailing tab
  If Left(strStaNum, 1) = Chr(9) Then
   n2 = Len(strStaNum)
   strStaNum = Right(strStaNum, (n2 - 1))
  End If
  If Right(strStaNum, 1) = Chr(9) Then
   n2 = Len(strStaNum)
   strStaNum = Left(strStaNum, (n2 - 1))
  End If
' retrim leading or trailing spaces
   strStaNum = Trim(strStaNum)
' check for proper length ' 8-12 characters
10 n2 = Len(strStaNum)
If n2 >= 8 And n2 <= 12 Then
 'check each character to ensure it is a number
  cnum = 0
  For ci = 1 To n2
   n1 = Mid(strStaNum, ci, 1)
   For cj = 0 To 9
    If n1 = cj Then
     cnum = cnum + 1
     GoTo 15
    End If
   Next cj
15  Next ci
  If cnum = 8 Then
   iEc = 0
   Exit Sub
  Else
   iEc = 2 'nonnumeric response
   Exit Sub
  End If
 ' if less than 8 declare error 1 and exit
 ElseIf n2 < 8 Then
  iEc = 1 'error station number too short
  Exit Sub
 'if greater than 12 try to trim left or right
 ElseIf n2 > 12 Then
  iEc = 3 'error station number too long
  Exit Sub
 End If
 Exit Sub
Err_ChkSta:
 If Err.Number = 13 Then
  If imode = 1 Then
   strErrMsg = " Error character number: " & ci & " is not an integer please correct"
   MsgBox strErrMsg
  End If
 Else
  If imode = 1 Then
  MsgBox "Other Error"
  End If
 End If
 iEc = 2
 Exit Sub
End Sub
Sub ckdate(StrYear As String, strmo As String, strday As String, ckdate As Date)
'
' Purpose:
' To take an input integer check dates and fix
' To be used for date values
' History:
' Version 1.0 April 2004 by G.E. Granato
' Arguments
Dim Intyr As Integer
Dim Intmo As Integer
Dim Intday As Integer
On Error GoTo Err_ckdate:
ckdate = CDate(strmo & "/" & strday & "/" & StrYear)
Exit Sub
Err_ckdate:
MsgBox "Error in date value please check year, month, and day (remember leap year)."
ckdate = Now
End Sub
Sub ChkFile(strStaDir As String, strStaNum As String, iEc As Integer, imode As Integer)
'
' Purpose:
' To check that a file exists for each station number and that it has data
' History:
' Version 1.0 May 2004 by G.E. Granato
' strStaDir           'input NWIS station number directory as string
' strStaNum           'input NWIS station number as string
' iec                 'output error code 0 = everything ok
' imode               ' mode 1= interactive 2= batch
' Arguments
Dim strErrMsg As String           ' Error string
Dim strFile As String
Dim lngFlen As Long
Dim bnFileExists As Boolean
On Error GoTo Err_ChkFile:
iEc = 0
strFile = strStaDir & strStaNum & "Q.txt"

' See if the file exists
bnFileExists = bnCheckFile(strFile)

If bnFileExists = False Then
 iEc = 2
 Exit Sub
End If
' see if the file is long enough 3 years of data?
lngFlen = FileLen(strFile)

If lngFlen < 30000 Then
 iEc = 2
 Exit Sub
End If

Exit Sub

Err_ChkFile:
 If Err.Number = 13 Then
  If imode = 1 Then
   strErrMsg = " Error character number: " & iEc & " is not an integer please correct"
   MsgBox strErrMsg
  End If
 Else
  If imode = 1 Then
  MsgBox "Other Error"
  End If
 End If
 iEc = 3
 Exit Sub
End Sub

Public Function bnCheckFile(strStaFile As String) As Boolean
'
' Purpose:
' To check that file exists for processing or other action
' History:
' Version 1.0 May 2004 by G.E. Granato
' strStaFile is a string that includes the dive, directory and filename
' for the file of interest
'
' Arguments
  If Dir$(strStaFile) <> "" Then  'vb intrinsic file function
   bnCheckFile = True
  Else
   bnCheckFile = False
  End If
End Function

